//	Direct X 9 Sample Program 
//  Œ肵Ar[Wi_jYSɉ]
//  ɃeNX`[𒣂
//	32bit/64bit }`oCg/UnicodeΉ Visual C++ 2008   2011/3/17

#define     szClassName        TEXT("Sphere Texture")

#define TIME_SET 1000.0f


#define R 50.0f	//	a
#define VIEW_R 200.0f // Jʒu

#include <windows.h>
#include <d3dx9.h>
#include <tchar.h>

#pragma once
#pragma comment(lib,"d3d9.lib")
#pragma comment(lib,"d3dx9.lib")
#pragma comment(lib,"winmm.lib")

#define SAFE_RELEASE(p)         { if (p) { (p)->Release();  (p)=NULL; } }
#define FVF_TLVERTEX (D3DFVF_XYZ | D3DFVF_TEX1)


HWND                    hWnd;
LPDIRECT3D9             pD3D;
LPDIRECT3DDEVICE9       pDev;
D3DPRESENT_PARAMETERS   D3DPPWin;
D3DLIGHT9               Light;
D3DMATERIAL9            Material;

LPD3DXMESH              pMeshApp = NULL;
LPD3DXMESH              pMeshApp2 = NULL;
LPDIRECT3DTEXTURE9      g_pTextures;

DWORD start;	//	vOJñVXe

HRESULT InitDevices(void);
void  SetupMatrices(void);
void Draw(void);
void Cleanup(void);
LRESULT CALLBACK WndProc(HWND hWnd,UINT msg,WPARAM wParam,LPARAM lParam);

// _tH[}bg̒`
struct  TLVERTEX{
	float       x,y,z;
    float       tu,tv;
};



int WINAPI WinMain(HINSTANCE hInst, HINSTANCE, LPSTR, int){
	MSG     msg;

    WNDCLASSEX wc = {
		sizeof(WNDCLASSEX),CS_CLASSDC,WndProc,0L,0L,hInst,
                NULL,NULL,NULL,NULL,szClassName,NULL
	};
    if (RegisterClassEx(&wc)==0)
		return FALSE;
    hWnd = CreateWindowEx(0,szClassName,szClassName,WS_OVERLAPPEDWINDOW,
                            CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,
                            NULL,NULL,hInst,NULL);
    if (FAILED(InitDevices()))
		return FALSE;
	start=timeGetTime();

    ShowWindow(hWnd,SW_SHOWDEFAULT);
    UpdateWindow(hWnd);
    ZeroMemory(&msg,sizeof(msg));
    while(msg.message!=WM_QUIT){
		if (PeekMessage(&msg,NULL,0U,0U,PM_REMOVE)){
			TranslateMessage(&msg);
            DispatchMessage(&msg);
        }
        else{
            Draw();
        }
    }
    Cleanup();
    UnregisterClass(szClassName,wc.hInstance);
    return 0;
}

void convert(float x,float y,float z,float r,float& u,float& v){
	float q;
	float q2;
	q=atan2(z,x);

	u=q / (2.0f * 3.1415f);
	q2=asin(y/r);
	v=(1.0f-q2/(3.1415f/2.0f))/2.0f;
	if(u>1.0)
		u=1.0;
}

//foCX/[h̏
HRESULT InitDevices(void){
    pD3D= NULL;
    pDev= NULL;

	HRESULT     hr;

	D3DDISPLAYMODE  dmode;

	// foCX/[h̏
	if(pD3D==NULL)
		pD3D = Direct3DCreate9(D3D_SDK_VERSION);
	if(pD3D==NULL)
		return E_FAIL;
	//݂̃fBXvC[h𓾂
	if(FAILED(pD3D->GetAdapterDisplayMode(D3DADAPTER_DEFAULT,&dmode)))
		return E_FAIL;

	// D3DDeviceIuWFNg̍쐬
	ZeroMemory(&D3DPPWin, sizeof(D3DPPWin));
	D3DPPWin.BackBufferFormat           = dmode.Format;
	D3DPPWin.BackBufferCount            = 1;
	D3DPPWin.SwapEffect                 = D3DSWAPEFFECT_DISCARD;
	D3DPPWin.Windowed                   = TRUE;
	D3DPPWin.EnableAutoDepthStencil     = TRUE;
	D3DPPWin.AutoDepthStencilFormat     = D3DFMT_D16;
	D3DPPWin.Flags                      = D3DPRESENTFLAG_LOCKABLE_BACKBUFFER;

	hr = pD3D->CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd,
				D3DCREATE_HARDWARE_VERTEXPROCESSING, &D3DPPWin, &pDev);
	if (FAILED(hr)){
		hr = pD3D->CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd,
				D3DCREATE_SOFTWARE_VERTEXPROCESSING, &D3DPPWin, &pDev);
		if (FAILED(hr)){
			hr = pD3D->CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_REF, hWnd,
				D3DCREATE_SOFTWARE_VERTEXPROCESSING, &D3DPPWin, &pDev);
			if (FAILED(hr)){
				MessageBox(NULL,TEXT("Create Device Error"),TEXT("Surface Error"),MB_OK);
				return E_FAIL;
			}
		}
	}
    //bV̐
    D3DXCreateSphere(pDev,R,32,32,&pMeshApp,NULL);

	pMeshApp->CloneMeshFVF(NULL, FVF_TLVERTEX,pDev,&pMeshApp2);
	LPDIRECT3DVERTEXBUFFER9 pVB=NULL;
	TLVERTEX* pVer=NULL;
	pMeshApp2->GetVertexBuffer(&pVB);
	pVB->Lock(0,0,(VOID**)&pVer,0);
	DWORD n;
	for(n=0;n<pMeshApp2->GetNumVertices();n++){ //_̐擾
		float u,v;
		convert(pVer[n].x,pVer[n].y,pVer[n].z,R,u,v);
		pVer[n].tu=u;
		pVer[n].tv=v;
	}
	pVB->Unlock();

	hr=D3DXCreateTextureFromFile(pDev,TEXT("Texture.jpg"),&g_pTextures);
	if (FAILED(hr)){
        MessageBox(NULL,TEXT("Texture Load Error"),TEXT("Error"),MB_OK);
  	    return E_FAIL; 
    }

	
    return  S_OK;
}

//`̐ݒ
void  SetupMatrices(void){
    D3DXMATRIX      matView;
    D3DXMATRIX      matProj;
	D3DXVECTOR3     ViewForm;	//(0.0f,0.0f,-200.0f);	//	ڂ̈ʒuۑ

	float rt=(float(timeGetTime()-start)/10.0f);	//	VXe^C]pZo
	ViewForm.x= (float)(VIEW_R*cos(rt/180*3.14));
	ViewForm.y= 0.0f;
	ViewForm.z= (float)(VIEW_R*sin(rt/180*3.14));

    //View W̐ݒ ViewFormڂ̈ʒu &D3DXVECTOR3(0.0f,0.0f,0.0f)ڂ̌ Ȃ킿y狗200ʒu猴_邱ƂɂȂ
    D3DXMatrixLookAtLH(&matView,&ViewForm,
                       &D3DXVECTOR3(0.0f,0.0f,0.0f),&D3DXVECTOR3(0.0f,1.0f,0.0f));
    pDev->SetTransform(D3DTS_VIEW,&matView);
    //ϊ̐ݒ Y̎p45x ZW 100`1000͈̔͂ˉe
    D3DXMatrixPerspectiveFovLH(&matProj,D3DXToRadian(45.0f),1.0f,100,1000); // ɊÂāAWnp[XyNeBuˉes쐬
    pDev->SetTransform(D3DTS_PROJECTION,&matProj);

	pDev->SetRenderState(D3DRS_WRAP0,D3DWRAPCOORD_0);

	pDev->SetRenderState(D3DRS_CULLMODE,D3DCULL_CCW);		//v̖ʂ
    pDev->SetRenderState(D3DRS_LIGHTING,FALSE);         	//CeBOȂ
    pDev->SetRenderState(D3DRS_ZENABLE,D3DZB_FALSE);    	//Zobt@gȂ

}

//`揈
void Draw(void){
    //œhԂď
    pDev->Clear(0,NULL,D3DCLEAR_TARGET|D3DCLEAR_ZBUFFER,D3DCOLOR_XRGB(0,0,0),1.0f,0);
    if (SUCCEEDED(pDev->BeginScene())){
	    pDev->SetTextureStageState(0,D3DTSS_COLORARG2,D3DTA_TEXTURE);
        SetupMatrices();
		pDev->SetFVF(FVF_TLVERTEX);

		pDev->SetTexture(0,g_pTextures);
        pMeshApp2->DrawSubset(0);
        pDev->EndScene();
    }
    pDev->Present(NULL,NULL,NULL,NULL);
}

//IuWFNg̊J
void Cleanup(void){
	SAFE_RELEASE(g_pTextures);
    SAFE_RELEASE(pMeshApp);
    SAFE_RELEASE(pMeshApp2);
	SAFE_RELEASE(pDev);
}

LRESULT CALLBACK WndProc(HWND hWnd,UINT msg,WPARAM wParam,LPARAM lParam){
    switch(msg){
	   case WM_CLOSE:
       case WM_DESTROY:
            PostQuitMessage(0);
            return 0L;
    }
    return DefWindowProc(hWnd,msg,wParam,lParam);
}



